package omnigkgui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue; Huang, Hsiao-Mei
 * @version      1.0
 */

public class AppFrame_AboutBox extends JDialog implements ActionListener {
    JPanel panel1 = new JPanel();
    JPanel panel2 = new JPanel();
    JPanel insetsPanel1 = new JPanel();
    JPanel insetsPanel2 = new JPanel();
    JPanel insetsPanel3 = new JPanel();
    JButton button1 = new JButton();
    JLabel imageLabel = new JLabel();
    JLabel label1 = new JLabel();
    JLabel label2 = new JLabel();
    JLabel label3 = new JLabel();
    JLabel label4 = new JLabel();
    JLabel label5 = new JLabel();
    JLabel label6 = new JLabel();
    JLabel label7 = new JLabel();
    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    FlowLayout flowLayout = new FlowLayout();
//  BorderLayout borderLayout3 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout();
    ImageIcon imageLogo = new ImageIcon(omnigkgui.AppFrame.class.getResource("images/CT-Logo.png"));
    String product = "GNU GateKeeper Graphic User Interface";
    String version = "Version 1.0";
    String copyright = "Copyright (c) 2002 Citron Network Inc.";
    String spaces = "";
    String comments1 = "This program is free software; you can redistribute it and/or modify it";
    String comments2 = "under the terms of the GNU General Public License as published by the ";
    String comments3 = "Free Software Foundation.";


    /** Construct the AppFrame_AboutBox object */
    public AppFrame_AboutBox(Frame parent) {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
        pack();
    }

    /** Component initialization */
    private void jbInit() throws Exception  {
        // imageLabel.setIcon(new ImageIcon(AppFrame_AboutBox.class.getResource("[Your Image]")));
        this.setTitle("About Citron");
        setResizable(false);
        panel1.setLayout(borderLayout1);
        panel2.setLayout(borderLayout2);
        insetsPanel1.setLayout(flowLayout);
//      insetsPanel2.setLayout(borderLayout3);
        insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        gridLayout1.setRows(7);
        gridLayout1.setColumns(1);
        label1.setHorizontalAlignment(SwingConstants.LEFT);
        label1.setText(product);
        label2.setHorizontalAlignment(SwingConstants.LEFT);
        label2.setText(version);
        label3.setHorizontalAlignment(SwingConstants.LEFT);
        label3.setText(copyright);
        label4.setHorizontalAlignment(SwingConstants.LEFT);
        label4.setText(spaces);
        label5.setForeground(Color.magenta);
        label5.setHorizontalAlignment(SwingConstants.LEFT);
        label5.setText(comments1);
        label6.setForeground(Color.magenta);
        label6.setHorizontalAlignment(SwingConstants.LEFT);
        label6.setText(comments2);
        label7.setForeground(Color.magenta);
        label7.setHorizontalAlignment(SwingConstants.LEFT);
        label7.setText(comments3);
        insetsPanel3.setLayout(gridLayout1);
        insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
        button1.setText("Ok");
        button1.addActionListener(this);
        insetsPanel3.add(label1, null);
        insetsPanel3.add(label2, null);
        insetsPanel3.add(label3, null);
        insetsPanel3.add(label4, null);
        insetsPanel3.add(label5, null);
        insetsPanel3.add(label6, null);
        insetsPanel3.add(label7, null);
        panel2.add(insetsPanel2, BorderLayout.WEST);
        imageLabel.setIcon(imageLogo);
        insetsPanel2.add(imageLabel, null);
        panel2.add(insetsPanel3, BorderLayout.CENTER);
        panel1.add(insetsPanel1, BorderLayout.SOUTH);
        insetsPanel1.add(button1, null);
        panel1.add(panel2, BorderLayout.NORTH);
        this.getContentPane().add(panel1, BorderLayout.CENTER);
    }

    /** Overridden so we can exit when window is closed */
    protected void processWindowEvent(WindowEvent e) {
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    /** Close the dialog */
    void cancel() {
        dispose();
    }

    /** Close the dialog on a button event */
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == button1) {
            cancel();
        }
    }
}