package omnigkgui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.text.*;
import javax.swing.tree.*;
import java.io.*;
import java.text.*;
import javax.swing.event.*;


import omnigkgui.util.*;
import omnigkgui.gkcmd.*;


/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue; Huang, Hsiao-Mei
 * @version      1.0
 */

public class GateKeeper extends JPanel implements ActionListener, OmniGkGUIConstants {
    static final String CONNECT = "connect";
    static final String DISCONNECT = "disconnect";
    static final String REFRESHALL = "refreshall";
    static final String CLEARBROWSER = "clearbrowser";
    static final String BUTTONLISTMODE = "buttonmode";
    static final String TREELISTMODE = "treemode";
    static final String CLOSESESSION = "closesession";
    static final String TOTALUSETIME = "totalusetime";

    // images for GateKeeper's ToolBar's icons

    // listeners to gatekeeper
    protected GkClient listener;
    protected GkCommand commander;

    // App's environment varables
    private String hostname;
    private int num_port;
    private String currentListMode = BUTTONLISTMODE;

    private GateKeeper thisGK = null;
    private Hashtable epTable = new Hashtable();

    // GUI components
    protected JToolBar gkToolBar;
    protected JScrollPane textScrollPane;
    protected JTextPane textPane;
    protected JPanel endpointListPane;
    protected JScrollPane listScrollPane;
    protected GridBagLayout listLayout;
    protected GridBagConstraints listConstraints;
    protected JPanel listPane;
    protected JTree listTree;

    // listTree default nodes
    protected DefaultTreeModel listTreeModel;
    protected DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("All Registered Endpoints");
    protected DefaultMutableTreeNode terminalClass = new DefaultMutableTreeNode("Terminal");
    protected DefaultMutableTreeNode gatewayClass = new DefaultMutableTreeNode("Gateway");
    protected DefaultMutableTreeNode h323ProxyClass = new DefaultMutableTreeNode("H323Proxy");
    protected DefaultMutableTreeNode miscEndpointClass = new DefaultMutableTreeNode("Miscellaneous");

    // JTextPane format for all kinds of RAS messages
    protected SimpleAttributeSet styleGeneralText = null;
    protected SimpleAttributeSet styleGeneralRAS = null;
    protected SimpleAttributeSet styleGkConfirm = null;
    protected SimpleAttributeSet styleGkReject = null;
    protected SimpleAttributeSet styleCDR = null;

    // EndPoint-list internal storage data structure
    protected Vector epList;
    // Root-TabbedPane container
    protected JTabbedPane rootTabbedPane;
    // View-TabbedPane container
    protected JTabbedPane viewTabbedPane;
    // CDR Table Model
    protected DefaultTableModel cdrTableModel;
    protected JTable cdrTable;
    protected JScrollPane cdrTScrollPane;

Color btnBgColor = new Color(25, 69, 165);
   class InputIDDlg extends JDialog implements ActionListener {

      static final String OK = " ok ";
      static final String CANCEL = "cancel";

      protected JLabel label = null;
      protected JLabel label2 = null;
      protected JLabel labelTime = null;
      protected JTextField txtID = null;
      protected JTextField txtTime = null;
      protected JButton okBtn = null;
      protected JButton cancelBtn = null;

      /**constructor*/
      public InputIDDlg(String title){
       // super(AppFrame.mainFrame, title, true);
        // set dialog inside the parent's window
        //setSize(300, 150);
        //setLocationRelativeTo(parent);
        label = new JLabel("Input the callerID: ");
        label2 = new JLabel("eg.'612'");
        labelTime = new JLabel("Total Use Time: ");
        okBtn = new JButton("  OK  ");
        okBtn.setActionCommand(OK);
        okBtn.addActionListener(this);
        cancelBtn = new JButton("Cancel");
        cancelBtn.setActionCommand(CANCEL);
        cancelBtn.addActionListener(this);
        txtID = new JTextField();
        txtID.setColumns(16);
        txtTime = new JTextField();
        txtTime.setColumns(16);

        this.addKeyListener(
              new KeyListener(){
                public void keyPressed(KeyEvent e){
                  if( e.getKeyChar() == e.VK_ENTER){
                  doOKBtn();
                  }
                }
                public void keyReleased(KeyEvent e){
                }
                public void keyTyped(KeyEvent e){
               }
             }
          );

            GridBagLayout dlgLayout = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            getContentPane().setLayout(dlgLayout);

            // set constraints and add the dialog label
            constraints.fill = GridBagConstraints.NONE;
            constraints.anchor = GridBagConstraints.NORTHWEST;
            constraints.gridwidth = GridBagConstraints.REMAINDER;
            constraints.gridheight = 1;
            constraints.insets = new Insets(5, 15, 0, 15);
            getContentPane().add(label, constraints);

             // set constraints and add the dialog label2
            constraints.fill = GridBagConstraints.NONE;
            constraints.anchor = GridBagConstraints.NORTHWEST;
            constraints.gridwidth = GridBagConstraints.REMAINDER;
            constraints.gridheight = 1;
            constraints.insets = new Insets(5, 15, 0, 15);
            getContentPane().add(label2, constraints);

            // set constraints and add the dialog ID field
            constraints.insets = new Insets(10, 15, 5, 15);
            getContentPane().add(txtID, constraints);

             // set constraints and add the dialog labelTime
            constraints.fill = GridBagConstraints.NONE;
            constraints.anchor = GridBagConstraints.NORTHWEST;
            constraints.gridwidth = GridBagConstraints.REMAINDER;
            constraints.gridheight = 1;
            constraints.insets = new Insets(5, 15, 0, 15);
            getContentPane().add(labelTime, constraints);

            // set constraints and add the dialog Time field
            constraints.insets = new Insets(10, 15, 5, 15);
            //txtTime = new JTextField("");
            getContentPane().add(txtTime, constraints);

            // set constraints and add the OK button and CANCEL button
            constraints.anchor = GridBagConstraints.CENTER;
            constraints.gridwidth = 1;
            constraints.gridheight = 1;
            constraints.insets = new Insets(10, 15, 10, 15);
            getContentPane().add(okBtn, constraints);

            constraints.gridx = GridBagConstraints.RELATIVE;
            constraints.insets = new Insets(10, 15, 10, 15);
            getContentPane().add(cancelBtn, constraints);

            pack();
            setVisible(true);
      }

      // OK button action
        public void actionPerformed(ActionEvent e) {
            enterKey(e);

        }
        // Make the OK button works
        public void enterKey(ActionEvent e){
           String cmd = e.getActionCommand();
            if (cmd == CANCEL) {
                dispose();
            } else if (cmd == OK) {
                doOKBtn();
            }
        }
          public void doOKBtn(){
          String id = txtID.getText();
          //GkClient gk = new GkClient();
          //gk.init(thisGK, hostname, num_port);
          //new Thread(gk).start();

          if(listener.totalUseTimeOfEP(id) != null){
            txtTime.setText(listener.totalUseTimeOfEP(id));
            txtTime.updateUI();
            //this.update();
          } else {
            txtTime.setText("0");

          }
          //dispose();
        }

    } // end of InputIDDlg class definitation

    class InDlgEP extends JDialog {
            protected JLabel labEP = null;
            protected JButton btnRemove = null;
            protected String epid = null;
            protected Vector infoVec = null;

            public void closeDialog(){
                this.dispose();
            }

            public InDlgEP(Vector infoVec){
		 super((java.awt.Frame)null, (String)infoVec.get(0), true);
                 this.infoVec = infoVec;
                 epid = (String)infoVec.get(0);
                 labEP = new JLabel();
                 labEP.setText(getInitDetailInfo(
                       (String)infoVec.get(0),
                       (String)infoVec.get(1),
                       (String)infoVec.get(2),
                       new ParseAlias((String)infoVec.get(3))
                  ));

		    btnRemove = new JButton("Remove this End Point from GK");
                    btnRemove.addActionListener(
                      new ActionListener(){
                          public void actionPerformed(ActionEvent e){
                              doRemoveEP();
                              closeDialog();
                          }
                      }
                    );
                    this.getContentPane().setLayout(new BorderLayout());
                    this.getContentPane().add(labEP, BorderLayout.NORTH);
                    this.getContentPane().add(btnRemove, BorderLayout.SOUTH);

              }

	public void doRemoveEP(){
               listener.removeEPOnGK(infoVec);
            }
          }

        private java.lang.String curEPID = null;
        private java.util.Hashtable epTab = new Hashtable();
    /** Construct the GateKeeper object */
    GateKeeper(String _hostname, int _num_port, JTabbedPane tabRoot) {
        hostname = _hostname;
        num_port = _num_port;
        rootTabbedPane = tabRoot;
        thisGK = this;

        viewTabbedPane = new JTabbedPane();
        listener = new GkClient();
        commander = new GkCommand();
        epList = new Vector();

        // create the CDR table model
        String[] headings = new String[] { OmniGkGUIConstants.CALL_NUMBER, OmniGkGUIConstants.START_TIME,
                                            OmniGkGUIConstants.END_TIME, OmniGkGUIConstants.USE_TIME, OmniGkGUIConstants.ACCOUNT,
                                            OmniGkGUIConstants.DIALED_CODE, OmniGkGUIConstants.CALLER_IP, OmniGkGUIConstants.CALLEE_IP };
        Object[][] data = { };
        cdrTableModel = new DefaultTableModel(data, headings);
        cdrTable = new JTable(cdrTableModel);
        cdrTable.setBorder(new LineBorder(Color.pink, 3, true));
        cdrTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        cdrTable.setRowHeight(20);
        cdrTable.setSelectionBackground(new Color(244, 136, 215));
        cdrTable.setSelectionForeground(Color.blue);
        cdrTScrollPane = new JScrollPane(cdrTable);

    }
    public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();
        // react to buttons
        if (command == CLOSESESSION) {
            epList.removeAllElements();
            //listPane.removeAll();
            shownEndPointPaneRemoveAll();
            int totalTabNum = rootTabbedPane.getTabCount();
            int selected = rootTabbedPane.getSelectedIndex();
            if (totalTabNum > 0) {
                rootTabbedPane.remove(selected);
            }
            listener.stop();
            commander.stop();
        } else if (command == CONNECT) {
            new Thread(listener).start();
            new Thread(commander).start();
        } else if (command == DISCONNECT) {
            epList.removeAllElements();
            //listPane.removeAll();
            //listPane.updateUI();
            shownEndPointPaneRemoveAll();
            shownEndPointPaneUpdateUI();
            listener.stop();
            commander.stop();
            flushTextPane();
        } else if (command == REFRESHALL) {
            epList.removeAllElements();
            //listPane.removeAll();
            //listPane.updateUI();
            shownEndPointPaneRemoveAll();
            shownEndPointPaneUpdateUI();
            listener.refresh();
            int rowCount = cdrTable.getRowCount();
            removeCDRRecord(0, rowCount);
        } else if (command == CLEARBROWSER) {
            //listPane.updateUI();
            shownEndPointPaneUpdateUI();
            listener.refreshWithoutCommands();
        } else if (command == BUTTONLISTMODE) {
            // set currentListMode to this mode
            currentListMode = command;
            shownEndPointPaneModeChanged();
        } else if (command == TREELISTMODE) {
            // set currentListMode to this mode
            currentListMode = command;
            shownEndPointPaneModeChanged();
        } else if (command == TOTALUSETIME){
            InputIDDlg idDlg = new InputIDDlg("Calculate the total use time");
            idDlg.setLocation(300,300);

        }
    }

    public void addEndpoint(String _epid, String _alias, String _eptype, String _epip) {


	 if (!endpointExists(_epid)) {
            ParseAlias alias = new ParseAlias(_alias);
            String _show_alias = " " + alias.getDialedDigits();
            String name = null;
            if ((name = alias.getH323ID()) == null)
                name = "UnknowID";
            _show_alias += "    User : " + name;

            JButton ep = new JButton(_show_alias);

        // Mark button as _epid use
            ep.setActionCommand(_epid);

            // Save Information into Hashtable for other use
            Vector tempVec = new Vector();
            tempVec.addElement(_epid);
            tempVec.addElement(_eptype);
            tempVec.addElement(_epip);
            tempVec.addElement(_alias);
            epTab.put(_epid, tempVec);

     // add anonymous MouseListener for "mouseEntered" and "mouseExited" events
            ep.addMouseListener(
                new MouseAdapter() {
                    public void mouseEntered(MouseEvent e) {
                        JButton tmpBtn = (JButton)e.getComponent();
                        tmpBtn.setBorder(new BevelBorder(BevelBorder.LOWERED, Color.blue, Color.blue));
                    }
                    public void mouseExited(MouseEvent e) {
                        JButton tmpBtn = (JButton)e.getComponent();
                        tmpBtn.setBorder(new BevelBorder(BevelBorder.RAISED, Color.white, Color.gray));
                    }
                }
            );
            ep.addActionListener(
              new ActionListener(){
                public void actionPerformed(ActionEvent e){
                      doEPActPerform(e);
                }
              }
            );
            ep.setBorder(new BevelBorder(BevelBorder.RAISED, Color.white, Color.gray));
            ep.setToolTipText(getInitDetailInfo(_epid, _eptype, _epip, alias));

            // set the icon for every type of H323 endpoint
            if (_eptype.equals("terminal"))
                ep.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/terminal.gif")));
            else if (_eptype.equals("gateway"))
                ep.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/gateway.gif")));
            else
                ep.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/device.gif")));

            ep.setHorizontalAlignment(SwingConstants.LEFT);
            ep.setFont(new Font("Helvetica", Font.ITALIC, 15));
            EndPoint newEP = new EndPoint(_epid, _epip, _alias, _eptype, ep);
            epList.addElement(newEP);

            DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(ep.getText(), false);
            newEP.treeNode = newNode;
            //epList.addElement(new EndPoint(_epid, _epip, _alias, _eptype, ep));
            setEndpointState(_epid, EndPoint.AVAILABLE);
//          listLayout.setConstraints(ep, listConstraints);
            /*
            if (listPane.getComponentCount() < OmniGkGUIConstants.MAX_LIST_ENDPOINT_NUMS)
                listPane.add(ep);
            listPane.updateUI();
            */
            shownEndPointPaneAdd(newEP);
        } else {
            EndPoint getEP = getEndpointByEPID(_epid);
            getEP.button.setToolTipText(getEP.getEPDetailInfo());
            if (!_alias.equals(getEP.epAlias)) {
                ParseAlias alias = new ParseAlias(_alias);
                String _show_alias = " "  + alias.getDialedDigits();
                String name = null;
                if ((name = alias.getH323ID()) == null)
                    name = "UnknowID";
                _show_alias += "    User : " + name;

//              getEP.button.setToolTipText(getInitDetailInfo(_epid, _eptype, _epip, alias));

                getEP.epAlias = _alias;
                getEP.button.setText(_show_alias);
                getEP.button.updateUI();
            }
            if (!_eptype.equals(getEP.epType)) {
                // reset the icon for every type of H323 endpoint
                if (_eptype.equals("terminal"))
                    getEP.button.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/terminal.gif")));
                else if (_eptype.equals("gateway"))
                    getEP.button.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/gateway.gif")));
                else
                    getEP.button.setIcon(new ImageIcon(omnigkgui.AppFrame.class.getResource("images/device.gif")));
            }
        }
    }

    public void doEPActPerform(ActionEvent e){
      InDlgEP dlgEP = new InDlgEP((Vector)epTab.get(e.getActionCommand()));
      dlgEP.setLocation(300,300);
      dlgEP.setSize(300,320);
      dlgEP.show();
    }
    /** protected or private or some use-restricted interfaces */
    protected void append(String s, AttributeSet attributes) {
        Document d = textPane.getDocument();
        try {
            d.insertString(d.getLength(), s, attributes);

            // move the textPane's view
            if (textScrollPane != null) {
                Dimension textPaneSize = textPane.getSize();
                JViewport view = textScrollPane.getViewport();
                Dimension originViewSize = view.getExtentSize();
                Point originViewPos = view.getViewPosition();

                if (textPaneSize.height > originViewSize.height) {
                    Point newViewPos = new Point();
                    newViewPos.x = originViewPos.x;
                    newViewPos.y = textPaneSize.height - originViewSize.height + 45;
                    view.setViewPosition(newViewPos);
                    // set the new viewport position
                    textScrollPane.setViewport(view);
                }
            }

        //auto save log

        if(d.getLength()>=100000){
          //String dir = "/root/job/OmniGkGUI/src/omnigkgui/log/";
          File dirFile = new File("log/");
          if(!dirFile.isDirectory()){
            dirFile.mkdir();
          }
          //File output = new File(dir + fileName);
          File output = new File("log/gkgui.log");
          if(!output.isFile()){
            output.createNewFile();
            return;
          }
          BufferedWriter out = new BufferedWriter(new FileWriter(output, true));
            out.write(d.getText(0, d.getLength()), 0, d.getLength());
            d.remove(0, d.getLength());
            thisGK.appendLog("Connecting to gatekeeper at " + thisGK.getHostName() + ":" + thisGK.getPort() + "\n");
            //textPane.removeAll();
            out.close();

        }

      } catch (FileNotFoundException e) {
        e.printStackTrace();
      } catch (IOException e){
        e.printStackTrace();
      } catch(BadLocationException e){
        e.printStackTrace();
      }
    }
    public void appendLog(String str) {
        if (textPane != null) {
            if (str.startsWith("RCF") || str.startsWith("ACF") || str.startsWith("DCF") ||
                str.startsWith("UCF") || str.startsWith("BCF") || str.startsWith("LCF"))
                append(str, styleGkConfirm);
            else if (str.startsWith("RRJ") || str.startsWith("ARJ") || str.startsWith("DRJ") ||
                str.startsWith("URJ") || str.startsWith("BRJ") || str.startsWith("LRJ"))
                append(str, styleGkReject);
            else if (str.startsWith("URQ") || str.startsWith("IRQ") || str.startsWith("IRR") ||
                str.startsWith("IACK") || str.startsWith("INAK"))
                append(str, styleGeneralRAS);
            else if (str.startsWith("CDR"))
                append(str, styleCDR);
            else
                append(str, styleGeneralText);
        }
    }

    public void dropExitCall(String _epid, String _callRF) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                if (_callRF.equals("CDRSRC")) {
                    // dropExitCall call from CDR message
                    ep.delCurrentOutCall();
                    ep.addTotalOutCall();
                } else if (_callRF.equals("CDRDEST")) {
                    // dropExitCall call from CDR message
                    ep.delCurrentInCall();
                    ep.addTotalInCall();
                } else if (ep.findCallRecord(_callRF)) {
                    // decrease one to active call
                    // and remove the call record from table
                    ep.removeCallRecord(_callRF);
                    ep.delActiveCall();
                } // else maybe duplicate DCF, just do nothing
                // update the button's ToolTipText for endpoint detail info
                ep.button.setToolTipText(ep.getEPDetailInfo());

                return;
            }
        }
    }
    private boolean endpointExists(String _epid) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                return true;
            }
        }
        return false;
    }
    public void flushTextPane() {
        if (textPane != null) {
            Document d = textPane.getDocument();
            try {
                d.remove(0, d.getLength());
            } catch (BadLocationException ble) {

            }
            append(OmniGkGUIConstants.LOG_TITLE_MSG, null);
        }
    }
    private EndPoint getEndpointByEPID(String _epid) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                return ep;
            }
        }
        return null;
    }
    protected String getHostName() {
        return hostname;
    }
    protected String getInitDetailInfo(String epid, String eptype, String epip, ParseAlias alias) {
        // set the detail endpoint information
        String detailInfo = "";
        detailInfo = "<html><font size=5 color=#8080C0><center>" +
                            "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                            " Endpoint Information " +
                            "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                            "</center></font><hr>";
        detailInfo += "<center><table border=0 width=100% align=center>";

        int ipIndex = 0;
        String detail_IP = "";
        if ((ipIndex = epip.indexOf(":")) != -1)
            detailInfo +=
                        "<tr>" +
                                "<td width=40% align=left>" +
                                        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                        "<font size=4>" +
                                                "EP-IP :" +
                                        "</font>" +
                                "</td>" +
                                "<td width=60% align=left>" +
                                        "<font size=4 color=#FE821D><b><i>" +
                                                epip.substring(0, ipIndex) + "&nbsp;&nbsp;" +
                                        "</i></b></font>" +
                                        "<font size=3 color=#0000FF><b><i>" +
                                                epip.substring(ipIndex + 1) +
                                        "</i></b></font>" +
                                "</td>" +
                        "</tr>";
        else
            detailInfo +=
                        "<tr>" +
                                "<td width=40% align=left>" +
                                        "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                        "<font size=4>" +
                                                "EP-IP :" +
                                        "</font>" +
                                "</td>" +
                                "<td width=60% align=left>" +
                                        "<font size=4 color=#FE821D><b><i>" +
                                                epip +
                                        "</i></b></font>" +
                                "</td>" +
                        "</tr>";

        detailInfo +=
                    "<tr>" +
                            "<td width=40% align=left>" +
                                    "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                    "<font size=4>" +
                                            "EP-Type :" +
                                    "</font>" +
                            "</td>" +
                            "<td width=60% align=left>" +
                                    "<font size=4 color=#FE821D><b><i>" +
                                            eptype.replace(',', '&') +
                                    "</i></b></font>" +
                            "</td>" +
                    "</tr>";

        detailInfo +=
                    "<tr>" +
                            "<td width=40% align=left>" +
                                    "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                    "<font size=4>" +
                                            "EP-ID :" +
                                    "</font>" +
                            "</td>" +
                            "<td width=60% align=left>" +
                                    "<font size=4 color=#FF0000><b><i>" +
                                            epid +
                                    "</i></b></font>" +
                            "</td>" +
                    "</tr>";

        detailInfo +=
                    "<tr>" +
                            "<td width=40% align=left>" +
                                    "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                    "<font size=4>" +
                                            "EP-Alias :" +
                                    "</font>" +
                            "</td>" +
                            "<td width=60% align=left></td>" +
                    "</tr>";
        // print the "DialedDigits" and "H323ID" format H323 alias
        Vector tmpVec = null;
        if ((tmpVec = alias.getDialedDigitsValues()) != null) {
            detailInfo +=
                        "<tr>" +
                                "<td width=40% align=left></td>" +
                                "<td width=60% align=left>" +
                                        "<font size=3><b>" +
                                                "[DialedDigits]" +
                                        "</b></font>" +
                                "</td>" +
                        "</tr>";
            int size = tmpVec.size();
            for (int i = 0; i < size; i++) {
                detailInfo +=
                            "<tr>" +
                                    "<td width=40% align=left></td>" +
                                    "<td width=60% align=left>" +
                                            "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                            "<font size=3 color=#FF00FF>" +
                                                    tmpVec.get(i).toString() +
                                            "</font>" +
                                    "</td>" +
                            "</tr>";
            }
        }
        tmpVec = null;
        if ((tmpVec = alias.getH323IDValues()) != null) {
            detailInfo +=
                        "<tr>" +
                                "<td width=40% align=left></td>" +
                                "<td width=60% align=left>" +
                                        "<font size=3><b>" +
                                                "[H323ID]" +
                                        "</b></font>" +
                                "</td>" +
                        "</tr>";
            int size = tmpVec.size();
            for (int i = 0; i < size; i++) {
                detailInfo +=
                            "<tr>" +
                                    "<td width=40% align=left></td>" +
                                    "<td width=60% align=left>" +
                                            "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                                            "<font size=3 color=#FF00FF>" +
                                                    tmpVec.get(i).toString() +
                                            "</font>" +
                                    "</td>" +
                            "</tr>";
            }
        }
        detailInfo += "</table></center><br></html>";
        return detailInfo;
    }
    protected int getPort() {
        return num_port;
    }
    /** public Interfaces */
    /** Component initialization */
    public void jbInit() {
        // create and initialize the JToolBar
        gkToolBar = new JToolBar();
        // create the simple text styles
        styleGeneralText = new SimpleAttributeSet();
        StyleConstants.setForeground(styleGeneralText, Color.black);
        StyleConstants.setFontSize(styleGeneralText, 16);
        styleGeneralRAS = new SimpleAttributeSet();
        StyleConstants.setForeground(styleGeneralRAS, new Color(97, 75, 158));
        StyleConstants.setFontSize(styleGeneralRAS, 14);
        StyleConstants.setBold(styleGeneralRAS, true);
        styleGkConfirm = new SimpleAttributeSet();
        StyleConstants.setForeground(styleGkConfirm, new Color(26, 100, 30));
        StyleConstants.setFontSize(styleGkConfirm, 14);
        StyleConstants.setBold(styleGkConfirm, true);
        styleGkReject = new SimpleAttributeSet();
        StyleConstants.setForeground(styleGkReject, new Color(188, 37, 33));
        StyleConstants.setFontSize(styleGkReject, 14);
        StyleConstants.setBold(styleGkReject, true);
        styleCDR = new SimpleAttributeSet();
        StyleConstants.setForeground(styleCDR, new Color(191, 79, 30));
        StyleConstants.setFontSize(styleCDR, 15);
        StyleConstants.setItalic(styleCDR, true);
        // create and set the left JTextArea panel
        textPane = new JTextPane();
        textPane.setForeground(Color.red);
        textPane.setFont(new Font("Helvetica", Font.PLAIN, 20));
        textPane.setEditable(false);
        append(OmniGkGUIConstants.LOG_TITLE_MSG, null);

        textScrollPane = new JScrollPane(textPane);

        // create and set the right JPanel panel
        endpointListPane = new JPanel(new BorderLayout());
        endpointListPane.setBackground(Color.blue);

        JLabel endpointListLabel = new JLabel("H323 EndPoint List at \"" + hostname + "\"", SwingConstants.CENTER);
        endpointListLabel.setForeground(Color.yellow);

        // create GridBagLayout and GridBagConstraints objects for future use
        listConstraints = new GridBagConstraints();
        listConstraints.gridx = 0;
        listConstraints.gridy = GridBagConstraints.RELATIVE;
        listConstraints.insets = new Insets(2, 4, 2, 4);
        listConstraints.gridwidth = 1;
        listConstraints.gridheight = 1;
        listConstraints.weightx = 1.0;
        listConstraints.weighty = 1.0;
        listConstraints.anchor = GridBagConstraints.CENTER;
        listConstraints.fill = GridBagConstraints.HORIZONTAL;

        listLayout = new GridBagLayout();
        listPane = new JPanel();
//      listPane.setLayout(listLayout);
        listPane.setLayout(new GridLayout(listPane.getComponentCount(), 1, 2, OmniGkGUIConstants.LIST_ENDPOINT_V_GAP_SIZE));
        //listPane.setLayout(new GridLayout(OmniGkGUIConstants.MAX_LIST_ENDPOINT_NUMS, 1, 2, OmniGkGUIConstants.LIST_ENDPOINT_V_GAP_SIZE));
        listPane.setBackground(Color.darkGray);

        endpointListPane.add(endpointListLabel, BorderLayout.NORTH, 0);
        endpointListPane.add(listPane, BorderLayout.CENTER, 1);
        listScrollPane = new JScrollPane(endpointListPane);

        // add all kinds of views to viewTabbedPane
        viewTabbedPane.setBackground(new Color(179, 179, 19));
        cdrTable.addMouseListener(new LogFileHandler(this));
        textPane.addMouseListener(new LogFileHandler(this));
        viewTabbedPane.addTab("GK Status Log", null, textScrollPane);
        viewTabbedPane.addTab("Call Detail Record", null, cdrTScrollPane);

        // Create and set the JSplitPane, then put the JTextArea
        // and JPanel objects on it
        JSplitPane splitPane =
                    new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, viewTabbedPane, listScrollPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setDividerSize(8);
        //splitPane.setDividerLocation((double)0.75);
        splitPane.setDividerLocation(450);
        splitPane.setResizeWeight((double)0.75);
        splitPane.setBackground(new Color(212, 208, 200));

        this.setLayout(new BorderLayout());
        this.add(gkToolBar, BorderLayout.NORTH);
        this.add(splitPane, BorderLayout.CENTER);
        this.setVisible(true);

        listener.init(this, hostname, num_port);
        commander.init(this, hostname, num_port);
        new Thread(listener).start();
        new Thread(commander).start();

    }
    public void processNewCall(String _epid, String _callRF, String _srcInfo) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                // add one to active call
                // and insert the call record to table
                if (!_srcInfo.equals("") && !ep.findCallRecord(_callRF)) {
                    ep.addActiveCall();
                    ep.insertCallRecord(_epid, _callRF);
                } // else maybe duplicate ACF, just do nothing
                // add one to current in-call or out-call
                if (!_srcInfo.equals("")) {
                    if (ep.isEqualEPByAliasList(_srcInfo))
                        ep.addCurrentOutCall();
                    else
                        ep.addCurrentInCall();
                }
                // update the button's ToolTipText for endpoint detail info
                ep.button.setToolTipText(ep.getEPDetailInfo());

                return;
            }
        }
    }
    public void removeCDRRecord(int start, int end) {
        for (int i = start; i < end; i++)
            cdrTableModel.removeRow(0);
    }


    public void removeEndpoint(String _epid) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                //listPane.remove(ep.button);
                shownEndPointPaneRemove(ep);
                epList.removeElementAt(i);
                //listPane.updateUI();
                shownEndPointPaneUpdateUI();
                return;
            }
        }
    }
    public void setEndpointState(String _epid, int _state) {
        for (int i = 0; i < epList.size(); i++) {
            EndPoint ep = (EndPoint) epList.elementAt(i);
            if (_epid.equals(ep.epID)) {
                ep.state = _state;
                if (_state == EndPoint.AVAILABLE) {
                    if (ep.getActiveCallNum() == 0) {
                        if (ep.epType.equals("gateway")) {
                            ep.button.setBackground(Color.blue);
                            ep.button.setForeground(Color.white);
                        } else if (ep.epType.equals("terminal"))
                            ep.button.setBackground(Color.green);
                        else
                            ep.button.setBackground(Color.yellow);
                        ep.button.updateUI();
                    }
                } else if (_state == EndPoint.TALKING) {
                    ep.button.setBackground(Color.red);
                    ep.button.updateUI();
                } else {
                    ep.button.setBackground(Color.white);
                    ep.button.updateUI();
                }
                return;
            }
        }
    }
    private void shownEndPointPaneAdd(EndPoint added) {
        if (currentListMode == BUTTONLISTMODE) {
           // if (listPane.getComponentCount() < OmniGkGUIConstants.MAX_LIST_ENDPOINT_NUMS)
                listPane.add(added.button);
            listPane.updateUI();
        } else if (currentListMode == TREELISTMODE) {
            if ((added.epType).equals("terminal")) {
                terminalClass.add(added.treeNode);
            } else if ((added.epType).equals("gateway")) {
                gatewayClass.add(added.treeNode);
            } else if ((added.epType).equals("gateway,gatekeeper")) {
                h323ProxyClass.add(added.treeNode);
            } else {
                miscEndpointClass.add(added.treeNode);
            }
            // update the listTree view
            listTree.updateUI();
        } else {
            // unknown show mode, just do nothing now
        }
    }
    private void shownEndPointPaneModeChanged() {
        if (currentListMode == BUTTONLISTMODE) {
            endpointListPane.remove(1);
            listPane = new JPanel();
            listPane.setLayout(new GridLayout(listPane.getComponentCount(), 1, 2, OmniGkGUIConstants.LIST_ENDPOINT_V_GAP_SIZE));
            //listPane.setLayout(new GridLayout(OmniGkGUIConstants.MAX_LIST_ENDPOINT_NUMS, 1, 2, OmniGkGUIConstants.LIST_ENDPOINT_V_GAP_SIZE));
            listPane.setBackground(Color.darkGray);
            // add listPane into endpointListPane
            endpointListPane.add(listPane, BorderLayout.CENTER, 1);

            // add current endpoints in epList into listPane
            for (int i = 0; i < epList.size(); i++)
                listPane.add(((EndPoint)epList.elementAt(i)).button);

            endpointListPane.updateUI();
        } else if (currentListMode == TREELISTMODE) {
            endpointListPane.remove(1);
            listTree = new JTree();
            rootNode.removeAllChildren();
            terminalClass.removeAllChildren();
            gatewayClass.removeAllChildren();
            h323ProxyClass.removeAllChildren();
            miscEndpointClass.removeAllChildren();
            rootNode.add(terminalClass);
            rootNode.add(gatewayClass);
            rootNode.add(h323ProxyClass);
            rootNode.add(miscEndpointClass);
            listTreeModel = new DefaultTreeModel(rootNode);
            listTree.setModel(listTreeModel);
            // add listPane into endpointListPane
            endpointListPane.add(listTree, BorderLayout.CENTER, 1);

            // add current endpoints in epList into listTree
            for (int i = 0; i < epList.size(); i++) {
                EndPoint tmpEP = (EndPoint) epList.elementAt(i);
                if ((tmpEP.epType).equals("terminal")) {
                    terminalClass.add(tmpEP.treeNode);
                } else if ((tmpEP.epType).equals("gateway")) {
                    gatewayClass.add(tmpEP.treeNode);
                } else if ((tmpEP.epType).equals("gateway,gatekeeper")) {
                    h323ProxyClass.add(tmpEP.treeNode);
                } else {
                    miscEndpointClass.add(tmpEP.treeNode);
                }
            }

     /**       listTree.addTreeSelectionListener(new TreeSelectionListener(){
              public void valueChanged(TreeSelectionEvent e){
                Object nodeInfo = rootNode.getUserObject();
                System.out.println(nodeInfo);
                doEPTreePerform(nodeInfo);
              }
            });
            listTree.expandRow(0);
            endpointListPane.updateUI();*/
        } else {
            // unknown show mode, just do nothing now
        }
    }
  /*  public void doEPTreePerform(Object _nodeInfo){

      InDlgEP dlgEP = new InDlgEP((Vector)epTab.get(_nodeInfo));
      dlgEP.setLocation(300,300);
      dlgEP.setSize(300, 300);
      dlgEP.show();
    }*/

    private void shownEndPointPaneRemove(EndPoint removed) {
        if (currentListMode == BUTTONLISTMODE) {
            listPane.remove(removed.button);
        } else if (currentListMode == TREELISTMODE) {
            if ((removed.epType).equals("terminal")) {
                terminalClass.remove(removed.treeNode);
            } else if ((removed.epType).equals("gateway")) {
                gatewayClass.add(removed.treeNode);
            } else if ((removed.epType).equals("gateway,gatekeeper")) {
                h323ProxyClass.add(removed.treeNode);
            } else {
                miscEndpointClass.add(removed.treeNode);
            }
        } else {
            // unknown show mode, just do nothing now
        }
    }
    private void shownEndPointPaneRemoveAll() {
        if (currentListMode == BUTTONLISTMODE) {
            listPane.removeAll();
        } else if (currentListMode == TREELISTMODE) {
            terminalClass.removeAllChildren();
            gatewayClass.removeAllChildren();
            h323ProxyClass.removeAllChildren();
            miscEndpointClass.removeAllChildren();
        } else {
            // unknown show mode, just do nothing now
        }
    }
    private void shownEndPointPaneUpdateUI() {
        if (currentListMode == BUTTONLISTMODE) {
            listPane.updateUI();
        } else if (currentListMode == TREELISTMODE) {
            listTree.updateUI();
        } else {
            // unknown show mode, just do nothing now
        }
    }
}
