package omnigkgui;

import javax.swing.UIManager;
import java.awt.*;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue; Huang, Hsiao-Mei
 * @version      1.0
 */

public class OmniGkGUI {
    boolean packFrame = false;

    /** Construct the application */
    public OmniGkGUI() {
        AppFrame frame = new AppFrame();

        // validate frames that have preset sizes
        // pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        // center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if ((frameSize.width > screenSize.width) || (frameSize.height > screenSize.height)) {
            frameSize.height = screenSize.height;
            frameSize.width = screenSize.width;
            frame.setSize(frameSize.width, frameSize.height);
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    /** Main method */
    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        new OmniGkGUI();
    }
}