package omnigkgui.gkcmd;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue; Huagn, Hisao-Mei
 * @version      1.0
 */

public interface GkCmdIDs {
    /** GK commands definition, totally 25 kinds of commands */

    // commands for showing endpoints' and calls' messages
    static final int GKCmdPrintAllRegistrations = 100;
    static final int GKCmdPrintAllRegistrarionsVerbose = 101;
    static final int GKCmdPrintCurrentCalls = 110;
    static final int GKCmdPrintCurrentCallsVerbose = 111;
    static final int GKCmdPrintAllCached = 120;

    // commands for doing some operation on endpoints
    static final int GKCmdFind = 130;
    static final int GKCmdFindVerbose = 131;
    static final int GKCmdDisconnectIP = 200;
    static final int GKCmdDisconnectCall = 201;
    static final int GKCmdDisconnectAlias = 202;
    static final int GKCmdDisconnectEndpoint = 203;
    static final int GKCmdUnregisterAllEndpoints = 210;
    static final int GKCmdUnregisterAlias = 211;
    static final int GKCmdUnregisterIP = 212;

    // commands for add-valued operations
    static final int GKCmdTransferCall = 300;
    static final int GKCmdMakeCall = 301;
    static final int GKCmdYell = 302;

    // commands for system operations
    static final int GKCmdHelp = 400;
    static final int GKCmdVersion = 401;
    static final int GKCmdStatistics = 402;
    static final int GKCmdWho = 403;

    // privileged commands, must do some protection
    static final int GKCmdDebug = 500;
    static final int GKCmdShutdown = 501;
    static final int GKCmdReload = 502;
    static final int GKCmdExit = 503;
}