package omnigkgui.gkcmd;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue; Huagn, Hisao-Mei
 * @version      1.0
 */

public class ShownMsgFrame extends JFrame {
    // global objects
    protected GkCommand commander = null;

    // default constructor
    public ShownMsgFrame() {
        super.setTitle("GK Commands");
        // super.setModal(true);

        try {
            mainInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public ShownMsgFrame(String title) {
        super.setTitle(title);
        // super.setModal(true);

        try {
            mainInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void mainInit() throws Exception {
        // change the default action when press close button
        // this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        // set the frame size and location on screen
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        frameSize.width = (screenSize.width * 3) / 4 ;
        frameSize.height = (screenSize.height * 3) / 4;
        this.setSize(frameSize.width, frameSize.height);
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

        // show the message frame
        this.setVisible(true);
    }

    /** public interfaces */
    public void setCommander(GkCommand cmd) {
        commander = cmd;
    }

    public GkCommand getCommander() {
        return commander;
    }

    /** methods must be over-written in sub-classes */
    protected void parseParams(String params) {
        // just do nothing
    }

    public String getOriginalParams() {
        // just do nothing, return null
        return null;
    }
}