package omnigkgui.util;

import java.io.*;
import java.util.*;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue
 * @version      1.0
 */

public class ParseAlias {
    // string for parsing
    protected String parseStr = null;

    // pointer to parse stirng's current char position
    protected int strPtr = 0;

    // H323 endpoint alias type
//  protected String e_dialedDigits = null;
//  protected String e_h323_ID = null;
//  protected String e_url_ID = null;
//  protected String e_transport_ID = null;
//  protected String e_email_ID = null;
//  protected String e_partyNumber = null;
//  protected String e_mobileUIM = null;
//  protected String e_unknown = null;

    // H323 endpoint alias type
    protected Vector e_dialedDigits = null;
    protected Vector e_h323_ID = null;
    protected Vector e_url_ID = null;
    protected Vector e_transport_ID = null;
    protected Vector e_email_ID = null;
    protected Vector e_partyNumber = null;
    protected Vector e_mobileUIM = null;
    protected Vector e_unknown = null;

    /** Construct the ParseAlias object */
    public ParseAlias(String toParse) {
        parseStr = toParse + "=";
        String alias = null;

        while ((alias = nextToken()) != null) {
            if (alias.indexOf(":", 0) != -1) {
                String aliasStr = alias.substring(0, alias.indexOf(":", 0));
                String tokenType = alias.substring((alias.indexOf(":", 0) + 1), alias.length());

                if (tokenType.compareToIgnoreCase("DialedDigits") == 0) {
                    if (e_dialedDigits == null) {
                        // initialize the vector
                        e_dialedDigits = new Vector();
                    }
                    e_dialedDigits.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("H323_ID") == 0) {
                    if (e_h323_ID == null) {
                        // initialize the vector
                        e_h323_ID = new Vector();
                    }
                    e_h323_ID.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("URL_ID") == 0) {
                    if (e_url_ID == null) {
                        // initialize the vector
                        e_url_ID = new Vector();
                    }
                    e_url_ID.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("Transport_ID") == 0) {
                    if (e_transport_ID == null) {
                        // initialize the vector
                        e_transport_ID = new Vector();
                    }
                    e_transport_ID.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("Email_ID") == 0) {
                    if (e_email_ID == null) {
                        // initialize the vector
                        e_email_ID = new Vector();
                    }
                    e_email_ID.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("PartyNumber") == 0) {
                    if (e_partyNumber == null) {
                        // initialize the vector
                        e_partyNumber = new Vector();
                    }
                    e_partyNumber.addElement((String) aliasStr);
                } else if (tokenType.compareToIgnoreCase("MobileUIM") == 0) {
                    if (e_mobileUIM == null) {
                        // initialize the vector
                        e_mobileUIM = new Vector();
                    }
                    e_mobileUIM.addElement((String) aliasStr);
                } else {
                    if (e_unknown == null) {
                        // initialize the vector
                        e_unknown = new Vector();
                    }
                    e_unknown.addElement((String) aliasStr);
                }
            }
        }
    }

    protected String nextToken() {
        String token = "";
        int start = strPtr, end = 0;

        try {
            if (((end = parseStr.indexOf("=", start)) != -1) && (end != start)) {
                token = parseStr.substring(start, end);
                strPtr = end + 1;
            } else {
                token = null;
            }
        } finally {
            return token;
        }
    }

    /** return alias format -- "DialedDigits" */
    // return the first element in vector, if vector is not empty; else return null
    public String getDialedDigits() {
        if ((e_dialedDigits != null) && (!e_dialedDigits.isEmpty()))
            return ((String) e_dialedDigits.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getDialedDigitsValues() {
        return e_dialedDigits;
    }


    /** return alias format -- "H323ID" */
    // return the first element in vector, if vector is not empty; else return null
    public String getH323ID() {
        if ((e_h323_ID != null) && (!e_h323_ID.isEmpty()))
            return ((String) e_h323_ID.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getH323IDValues() {
        return e_h323_ID;
    }


    /** return alias format -- "UrlID" */
    // return the first element in vector, if vector is not empty; else return null
    public String getUrlID() {
        if ((e_url_ID != null) && (!e_url_ID.isEmpty()))
            return ((String) e_url_ID.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getUrlIDValues() {
        return e_url_ID;
    }


    /** return alias format -- "TransportID" */
    // return the first element in vector, if vector is not empty; else return null
    public String getTransportID() {
        if ((e_transport_ID != null) && (!e_transport_ID.isEmpty()))
            return ((String) e_transport_ID.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getTransportIDValues() {
        return e_transport_ID;
    }


    /** return alias format -- "EmailID" */
    // return the first element in vector, if vector is not empty; else return null
    public String getEmailID() {
        if ((e_email_ID != null) && (!e_email_ID.isEmpty()))
            return ((String) e_email_ID.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getEmailIDValues() {
        return e_email_ID;
    }


    /** return alias format -- "PartyNumber" */
    // return the first element in vector, if vector is not empty; else return null
    public String getPartyNumber() {
        if ((e_partyNumber != null) && (!e_partyNumber.isEmpty()))
            return ((String) e_partyNumber.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getPartyNumberValues() {
        return e_partyNumber;
    }


    /** return alias format -- "MobileUIM" */
    // return the first element in vector, if vector is not empty; else return null
    public String getMobileUIM() {
        if ((e_mobileUIM != null) && (!e_mobileUIM.isEmpty()))
            return ((String) e_mobileUIM.get(0));
        else
            return null;
    }

    // return the whole elements in vector
    public Vector getMobileUIMValues() {
        return e_mobileUIM;
    }
}