package omnigkgui.util;

import java.io.*;
import java.sql.*;

/**
 * Title:        Citron Omni GateKeeper Graphic User Interface Version 1.0
 * Description:  This is the Citron's GateKeeper's user interface.
 *               Its purpose is to achieve using one interface, running everywhere !!
 * Copyright:    Copyright (c) 2001
 * Company:      Citron Inc.
 * @author       Kau, Kuang-Jiue
 * @version      1.0
 */

public class ParseDate {
    // date string for parsing
    protected String parseDateStr = null;

    // date tags
    protected String weekday = null;
    protected String year = null;
    protected String month = null;
    protected String day = null;
    protected String hour = null;
    protected String min = null;
    protected String sec = null;

    /** Construct the ParseDate object */
    public ParseDate(String toParse) {
        parseDateStr = toParse;

        weekday = (toParse.substring(0, 3)).trim();
        year = (toParse.substring(12, 16)).trim();
        month = (toParse.substring(8, 11)).trim();
        day = (toParse.substring(5, 7)).trim();
        hour = (toParse.substring(17, 19)).trim();
        min = (toParse.substring(20, 22)).trim();
        sec = (toParse.substring(23, 25)).trim();
    }

    // output the General string format
    public String toString() {
        return parseDateStr;
    }

    // output the GMT format string
    public String toGMTString() {
        return (day + " " + month + " " + year + " " + hour + ":" + min + ":" + sec + " GMT");
    }

    // output MySQL DateTime format string
    public String toMySQLDateTimeString() {
        String digit_mon = null;

        if (month.compareTo("Jan") == 0)
            digit_mon = "01";
        else if (month.compareTo("Feb") == 0)
            digit_mon = "02";
        else if (month.compareTo("Mar") == 0)
            digit_mon = "03";
        else if (month.compareTo("Apr") == 0)
            digit_mon = "04";
        else if (month.compareTo("May") == 0)
            digit_mon = "05";
        else if (month.compareTo("Jun") == 0)
            digit_mon = "06";
        else if (month.compareTo("Jul") == 0)
            digit_mon = "07";
        else if (month.compareTo("Aug") == 0)
            digit_mon = "08";
        else if (month.compareTo("Sep") == 0)
            digit_mon = "09";
        else if (month.compareTo("Oct") == 0)
            digit_mon = "10";
        else if (month.compareTo("Nov") == 0)
            digit_mon = "11";
        else
            digit_mon = "12";

        return (year + "-" + digit_mon + "-" + day + " " + hour + ":" + min + ":" + sec);
    }
}